﻿
/*	Copyright Christophe Bertrand.
		This file is available under this license: Ms-PL. See the file License.html in the archive. You will find a copy here: http://www.opensource.org/licenses/ms-pl.html
 */

using System.Windows;
using System.Collections.ObjectModel;
using System.Windows.Threading;
using System;

namespace AsyncListBox
{
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			var list = new ObservableCollection<OrdinaryAsyncListItemWithPriorityBinding>();
			for (int i = 0; i < 10; i++)
				list.Add(new OrdinaryAsyncListItemWithPriorityBinding());
			this.AsyncListBox.ItemsSource = list;
		}

		private void Button_Click_1(object sender, RoutedEventArgs e)
		{
			var list = new ObservableCollection<AdvancedAsyncListItemWithPriorityObject>();
			for (int i = 0; i < 10; i++)
				list.Add(new AdvancedAsyncListItemWithPriorityObject());
			this.AdvancedListBox.ItemsSource = list;
		}

		private void Button_Click_2(object sender, RoutedEventArgs e)
		{
			ObservableCollection<AdvancedAsyncListItemWithPriorityObject> list = this.AdvancedListBox.ItemsSource as ObservableCollection<AdvancedAsyncListItemWithPriorityObject>;
			foreach (var item in list)
			{
				item.Text1.Value = "Text 1 is modified";
			}
		}

		private void StartBoth_Click(object sender, RoutedEventArgs e)
		{
			// Launch both ListBoxes at the same time.

			// Stopwatch:
			stopwatchStart = DateTime.Now.Ticks;
			timer = new DispatcherTimer(new TimeSpan(1000000L), DispatcherPriority.Normal, delegate
			{
				double Duration = ((double)(DateTime.Now.Ticks - stopwatchStart) / 10000000.0);
				this.stopwatchStartText.Text = Duration.ToString("F1") + " seconds.";
				if (Duration >= 20.0)
					this.timer.Stop();
			}, this.Dispatcher);

			Button_Click(sender, e);
			Button_Click_1(sender, e);
		}
		private DispatcherTimer timer;
		private long stopwatchStart;
	}
}
